from glob import globs
from vbweights import w
from collections import deque
from bitcoding import B_dict

if globs['split'] == 0: # splitting based on set of base relations
   from basesplit import bsplit as split
elif globs['split'] == 1: # splitting based on horn set
   from hornsplit import hsplit as split

cardmult = max(w)
DALL = B_dict['DALL']
mrv_variables = set([])
               
def initialize_mrv_vars(ConMatrix, neighbors):
    mrv_variables.clear()
    Vars = len(ConMatrix)
    map(add_var,[(n,j) for n, i in enumerate(ConMatrix) for j in ConMatrix[n] if j > n and split[ConMatrix[n][j]-1][0] > 1 and ConMatrix[n][j] != DALL and neighbors[n] & neighbors[j]])

def add_var(var):
    'Add a new var'
    mrv_variables.add(var)
          
def remove_var(var):
    'Remove a var. Raise KeyError if empty.'
    mrv_variables.discard(var)
